define(function(require){


	var updateProperties = function(model, json){
		for (var name in json){
			var newValue = json[name];
			
			if (typeof(newValue) === "number" || typeof(newValue) === "string" || typeof(newValue) === "boolean"){
				//update primitive value
				if (model[name].isObservable)
					//Observable
					model[name](newValue);
				else
					//Plain primitive
					model[name] = newValue;
					
			} else if (typeof(newValue) === "object")
				//recurse
				updateProperties(model[name], newValue);
		}
	};
	
	return updateProperties;
});