define(function(require){

	var DataBind = require("./binding/DataBind"),
		EventBind = require("./binding/EventBind"),
		PrefixBind = require("./binding/PrefixBind"),
		TemplateBind = require("./binding/TemplateBind");
	
	//returns the json data, if any
	var getData = function(node){
			for (var i=0; i<node.childNodes.length; i++)
				if (node.childNodes[i].tagName === "desc"){
					var data;
					try{
						data = JSON.parse(node.childNodes[i].textContent);
					}catch(e){
						//TODO: more infos about failing node!
						throw "Invalid json markup: " + node.childNodes[i].textContent;
					}
					return data;
				}
		};
		
	var processNode = function(node, model, path, data, basePath){
	
		//Parse data from JSON desc if not supplied
		data = data === undefined ? getData(node) : data;
		
		if (data !== undefined){
			//binding data available
			
			if (TemplateBind(node, data, model, path, processNode, basePath))
				//Asnyc mode on this node, continue with other nodes
				return;
			
			if (PrefixBind(node, data, model, processNode, path))
				//Prefix was bound and processed, ignore further bindings
				return;	
			
			DataBind(node, data, model);
			EventBind(node, data, model);
		}
		
		if (node.childNodes) {
			//no binding specified
			
			for (var i=0; i<node.childNodes.length; i++)
				//Process children
				processNode(node.childNodes[i], model, path, undefined, basePath);
		}

	};
	
	return processNode;
});