define(function(){

	return function(initValue){

		//Current value
		var value = initValue,
			//listeners
			listeners = [];
		
		/*
			var model = {
				opacity: svgdatabind.observable(0.5)
			};
			model.opacity(1);//set
			var o = model.opacity();//get
			model.opacity.set(1)//alternative set
			o = model.opacity.get();//alternative get
		*/
		var ret = function(v){
		
			if (v === undefined)
				//Getter
				return ret.get();
			else
				//Setter
				ret.set(v);
		};
		
				//Marker
		ret.isObservable = true;

		//Resets the value to its initial state
		ret.reset = function(){
			ret.set(initValue);
		};

		//Returns true if initial value currently set
		ret.isReset = function(){
			return ret.get() == initValue;
		};

		//Increments the value by i, default: 1
		ret.increment = function(i){
			i = i ? i : 1;
			ret.set(ret.get()+i);
		};
		
		//Decrements the value by i, default: 1
		ret.decrement = function(i){
			i = i ? i : 1;
			ret.set(ret.get()-i);
		};
		
		//Returns the value
		ret.get = function(){
			return value;
		};

		//Sets the value
		ret.set = function(v){
			var oldValue = value;
			value = v;

			listeners.forEach(function(l){
				l(v, oldValue);
			});
		};

		//Adds a listener
		ret.addListener = function(l){
			listeners.push(l);
		};

		//removes a listener
		ret.removeListener = function(l){
			listeners = listeners.filter(function(cl){ return cl !== l; });
		};

		return ret;
	};

});
