define(function(require){

	return function(obj, name){
	
		var parts = name.split("."),
			parent = obj,
			parentPropertyName = name,
			o;
		
		
		for (var i=0; i<parts.length; i++){
		
			if (parent === undefined)
				throw "No parent found in chain: " + name + " @offset: " + i;
				
			if (i == parts.length-1)
				//property found
				parentPropertyName = parts[i];
			else
				//store object as parent
				parent = parent[parts[i]];
		};
	
		//The immediate parent object
		this.getParent = function(){
			return parent;
		};
		
		//Returns the final property name on the parent object
		this.getPropertyName = function(){
			return parentPropertyName;
		};
	
		//Returns the value
		this.get = function(){
			return parent[parentPropertyName];
		};
		
		//Sets the value
		this.set = function(value){
			parent[parentPropertyName] = value;
		};
		
	};

	
});
