define(function(require){

	//http://stackoverflow.com/questions/3346106/accessing-a-dom-object-defined-in-an-external-svg-file
    function fetchXML(url, callback){
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.onreadystatechange = function (evt) {
			if (xhr.readyState === 4)
				callback(xhr.responseXML);
        };
        xhr.send(null);
    }

	
	
	return function(url, el, callback){
	
		//String selector
		el = typeof(el) === "string" ? document.getElementById(el) : el;
		
		fetchXML(url,function(svg){
			//Chrome, firefox, other
			var n = document.importNode(svg.documentElement,true);
					
			if (el.tagName == "rect" && n.childNodes){
				//Template injection
				for (var i=0; i<n.childNodes.length; i++){
					var node = n.childNodes[i],
						x = +el.getAttribute("x"),
						y = +el.getAttribute("y");

					if (node.tagName == "g"){
					
						//Check if target(injected) node has transformation attribute
						if (node.transform && node.transform.baseVal && node.transform.baseVal.length > 0){
							//http://stackoverflow.com/questions/10349811/how-to-manipulate-translate-transforms-on-a-svg-element-with-javascript-in-chrom
							var xforms = node.transform.baseVal; // An SVGTransformList
							var firstXForm = xforms.getItem(0);       // An SVGTransform
							if (firstXForm.type == SVGTransform.SVG_TRANSFORM_TRANSLATE){
								x += firstXForm.matrix.e;
								y += firstXForm.matrix.f;
							}
						}
						node.setAttribute("transform", "translate("+x+","+y+")");
						callback( el.parentNode.appendChild(node) );
						return;
					}
				}
			} else {
				//Raw html injection
				el.appendChild(n);
				callback(n);
			}
		});
	
	};

});