define(function(require){

	return function(setter, startValue, endValue, delay){
		
		var value = startValue,
			diff = endValue - startValue,
			stepDelay = 10,
			steps = delay / stepDelay,
			increment = diff / steps;
	
		var update = function(){
			value += increment;			
			setter(value);
			
			if ( (diff < 0 && value > endValue) || (diff > 0 && value < endValue) )
				setTimeout(update, stepDelay);
		};
		
		update();
	};

});