define(function(require){

	var PropertyAccessor = require("../PropertyAccessor");

	return function(node, data, model){

		var dataBind = data["bind"],
			DataBindApply = require("./DataBindApply");

		for (var name in dataBind){
			//binding property
			var fieldRef = dataBind[name],
				//Empty config object
				cfg = {};
			
			if (typeof(fieldRef) === "string")
				//set name in config object
				cfg.name = fieldRef;
			else if (typeof(fieldRef) === "object")
				//config object
				cfg = fieldRef;
			else
				//unknown type
				throw "field: " + fieldRef + " is undefined!";
			
			//Create accessor
			var accessor = new PropertyAccessor(model, cfg.name);
			
			//Field available and binding defined
			DataBindApply(accessor.getParent(), accessor.getPropertyName(), name, node, cfg);
		}
	};
});