define(function(require){

	var PropertyAccessor = require("../PropertyAccessor");
	
	/**
	 * Maps an event
	 */
	var mapEvent = function(name, node, f){
		node["on" + name] = function(){ f(); };
	};
	
	return function(node, data, model){
		var events = data["events"];
		
		if (events === undefined)
			return;
					
		for (var name in events){
		
			var fieldName = events[name],
				accessor = new PropertyAccessor(model, fieldName),
				field = accessor.get();
			
			if (typeof(field) === "function")
				mapEvent(name, node, field);
			else
				throw "field: " + fieldName + " is not a function!";
		}
	};
});