define(function(require){
	return function(node, data, model, nodeProcessor, path){
		var prefix = data["prefix"];
		
		if (prefix === undefined)
			//no prefix
			return false;
		
		var newModel = model[prefix];
		
		if (newModel === undefined)
			throw "No such submodel: " + path + "." + prefix;
		
		//remove prefix property
		delete data.prefix;
		
		nodeProcessor(node, newModel, path + "." + prefix, data);
		
		return true; //no further binding
	};
});