define(function(require){

	var SVGLoad = require("svg-databind/SVGLoad"),
		UrlResolver = require("urlresolver");

	return function(node, data, model, path, processNode, basePath){
		var template = data["template"];
		/*
		{
			"template" : {
				"source": "template1.svg"
			}
		}
		*/
		
		if (template === undefined)
			//no template
			return false;
				
		//Remove template markup
		delete data.template;
		
		//Resolve url part
		var url = UrlResolver.resolve(basePath, template.source);
		
		SVGLoad(url, node, function(newNode){
			//remove container node
			node.parentNode.removeChild(node);
			
			//Insert template node
			processNode(newNode, model, path, data, basePath);
		});
		
		return true;
	};
});