
define(function(require){

	var SVGBind = require("./SVGBind"),
		ModelUpdate = require("./ModelUpdate"),
		Observable = require("./Observable"),
		SVGLoad = require("./SVGLoad");

	return {
		version: "1.0.0",
		//SVG data binder
		bind: SVGBind,
		//SVG ajax loader
		load: SVGLoad,
		//Combined function
		loadAndBind: function(url, el, model, callback){
			SVGLoad(url, el, function(){
			
				//Extract base-url for templates
				var baseUrl = url.substr(0, url.lastIndexOf("/"));
				
				SVGBind(el, model, baseUrl);
				if (typeof(callback) === "function")
					callback();
			});
		},
		//json object updater
		update: ModelUpdate,
		//Observable
		observable: Observable
	};

});
