define(function(require){

	var SVGDataBind = require("svg-databind");

	return {
		"Observable": function(assert, el){
			var o = SVGDataBind.observable();
			assert.equal(o(), undefined, "Initial undefined value");
			
			o(123);
			assert.equal(o(), 123, "new value");
			
			o.set(456);
			assert.equal(o.get(), 456, "new value with .set() and .get()");
			
			o.increment();
			assert.equal(o(), 457, "increment()");

			o.increment(10);
			assert.equal(o(), 467, "increment(10)");

			o.decrement();
			assert.equal(o(), 466, "decrement()");
			
			o.decrement(10);
			assert.equal(o(), 456, "decrement(10)");

			var count = 0;
			var l = function(newValue, oldValue){
				assert.equal(0, count++, "listener entry count");
				assert.equal(100, newValue, "new value in listener");
				assert.equal(456, oldValue, "old value in listener");
			};
			o.addListener(l);
			o(100);
			o.removeListener(l);
			o(200);
			
			assert.equal(o.isReset(), false, "isReset()");
			o.reset();
			assert.equal(o(), undefined, "reset()");
			assert.equal(o.isReset(), true, "isReset()");

			
		}
	};

});