define(function(require){

	var Resolver = {
		resolve: function(cwd, relUrl){		
			//Ensure trailing slash
			cwd = cwd.substr(cwd.length-1, 1) == "/" ? cwd : cwd + "/";
		
			if (relUrl.substr(0,2) === "./"){
				//Current dir
				
				//check for more traversal
				if (relUrl.substr(2,1) === ".") // ./../x/y or ././
					return Resolver.resolve(cwd, relUrl.substr(2));
				
				return cwd + relUrl.substr(2);
			} else if (relUrl.substr(0,3) === "../") {
				//parent dir
				var parentDir = cwd.substr(0,cwd.substr(0, cwd.length-1).lastIndexOf("/")+1);
				return Resolver.resolve(parentDir, relUrl.substr(1));
			} else {
				//absolute dir
				return relUrl;
			}
		
		}
	};
	
	return Resolver;

});